' Masakari.bas (DragDropWheelScroller.bas)
' written in QB64 v1.4 by Kaze, 2021-Jan-24
' Thanks go to the www.qb64.org/forum members for sharing useful excerpts/etudes
' Wow, this is nice indeed: http://www.qb64.org/wiki/Windows_Libraries

' Currently are implemented only:
' Mouse:
'       Button 1 - sets the cursor and the inverse line to the chosen position
'       Button 3 - PgDn
'       Wheel Up - Up
'       Wheel Dn - Dn
' Keyboard:
'        Up
'        Down
'        Left - still no sideways scroll
'        Right - still no sideways scroll
'        LCtrl+Home - going to the top left position
'        LCtrl+End  - going to the bottom left position
'        Alt+x or Alt+q - quit to the system, without demanding keypress.

_TITLE "MASAKARI 128x60, The 'Holy Axe' English Text Sidekick"
$EXEICON:'ColumnChart.ico'
_ICON
CONST RSHIFTkey& = 100303
CONST LSHIFTkey& = 100304
CONST RCTRLkey& = 100305
CONST LCTRLkey& = 100306
CONST RALTkey& = 100307
CONST LALTkey& = 100308

CONST BACKSPCkey& = 8
CONST TABkey& = 9
CONST SPACEkey& = 32
CONST ESCkey& = 27
CONST ENTERkey& = 13

CONST HOMEkey& = 18176
CONST ENDkey& = 20224

CONST INSkey& = 20992
CONST DELkey& = 21248

CONST PGUPkey& = 18688
CONST PGDNkey& = 20736

CONST LEFTkey& = 19200
CONST RIGHTkey& = 19712
CONST UPkey& = 18432
CONST DOWNkey& = 20480

IF INSTR(LCASE$(COMMAND$), "/help") THEN
    _SCREENHIDE
    $CONSOLE
    _CONSOLE ON
    _CONSOLETITLE "Masakari console window"
    _DEST _CONSOLE
    PRINT "Masakari, revision 2, written in QB64 by Kaze"
    PRINT "Usage: Masakari filename|/help"
    SYSTEM
    '_CONSOLE OFF
    '_SCREENSHOW
ELSE
    $CONSOLE
    _CONSOLE OFF
END IF

'DEFLNG A-Z
'_DEFINE A-Z AS _UNSIGNED _INTEGER64
_DEFINE A-Z AS _INTEGER64

$IF WINDOWS THEN
    DECLARE LIBRARY "mem"
        FUNCTION MemInUsePercent~&&
        FUNCTION TotalPhysicalMem~&&
        FUNCTION FreePhysicalMem~&&
        FUNCTION TotalPagingFile~&&
        FUNCTION FreePagingFile~&&
        FUNCTION TotalVirtualMem~&&
        FUNCTION FreeVirtualMem~&&
        FUNCTION FreeExtendedMem~&&
        FUNCTION GetCPULoad#
    END DECLARE
$END IF

_SCREENMOVE 102, 3
XdimCOL = 128
YdimROW = 44 ' ensure old laptops with 768pixels vertical will hold the whole window
wide& = _DESKTOPWIDTH
high& = _DESKTOPHEIGHT
IF high& > 1000 THEN YdimROW = 60
handle& = _NEWIMAGE(XdimCOL, YdimROW + 1, 0)
SCREEN handle&
_DEST handle&

' _DEST 0 refers to the present program SCREEN. You can use 0 to refer to the present program
'  SCREEN.

'_FONT 16 'wish we could use the old 8x16 bitmap/raster fonts from DOS times...

' Either one must be uncommented:
_DISPLAY
'_AUTODISPLAY 'no need of refreshing

TimeA = TIMER

PurpleFlag = 0
'PurpleFlag = 1

NormalFRGr = 3
IF PurpleFlag THEN NormalFRGr = 9
NormalBCKGr = 0
IF PurpleFlag THEN NormalBCKGr = 0

InverseFRGr = 0
IF PurpleFlag THEN InverseFRGr = 8
InverseBCKGr = 3
IF PurpleFlag THEN InverseBCKGr = 0

COLOR NormalFRGr, NormalBCKGr

PRINT "Current working directory path: "; CHR$(34); _CWD$; CHR$(34)
PRINT "User's program calling path: "; CHR$(34); _STARTDIR$; CHR$(34)
PRINT "Command line parameters sent when a program is started: "; CHR$(34); COMMAND$; CHR$(34)
PRINT "_OS$="; _OS$

'Y = CSRLIN 'save the row
'X = POS(0) 'save the column

REDIM FileArray$(1) 'create dynamic array: 3880000 alocates 532MB - bigger values need 570+MB and give "Out Of Memory"
DIM FileArrayWINDOW$(YdimROW)

$IF WINDOWS THEN
    _ACCEPTFILEDROP 'enables drag/drop functionality
    IF COMMAND$ = "" THEN PRINT: PRINT "Drag files from a folder and drop them in this window...": PRINT
$END IF

_DISPLAY
'pressakey$ = INPUT$(1)

a$ = ""
PostfixedToHeader = CSRLIN
DO

    LOCATE PostfixedToHeader, 1

    $IF WINDOWS THEN
        ' MEMUSAGE by Steve [
        ' GetCPULoad = 0 is idle, 1 is fully used.
        '  Multiply by 100 for a percentage
        PRINT "CPU used:              "; LTRIM$(STR$(INT((GetCPULoad * 10000) / 100))); "%"; SPACE$(18)
        PRINT "Memory used:           "; LTRIM$(STR$(MemInUsePercent)); "%"; SPACE$(18)
        PRINT "Total Physical Memory: ";
        PRINT AddCommas$(TotalPhysicalMem); " bytes"; SPACE$(18)
        PRINT "Free Physical Memory:  ";
        PRINT AddCommas$(FreePhysicalMem); " bytes"; SPACE$(18)
        PRINT "Total Paging File:     ";
        PRINT AddCommas$(TotalPagingFile); " bytes"; SPACE$(18)
        PRINT "Free Paging File:      ";
        PRINT AddCommas$(FreePagingFile); " bytes"; SPACE$(18)
        PRINT "Total Virtual Memory:  ";
        PRINT AddCommas$(TotalVirtualMem); " bytes"; SPACE$(18)
        PRINT "Free Virtual Memory:   ";
        PRINT AddCommas$(FreeVirtualMem); " bytes"; SPACE$(18)
        'PRINT "Free Extended Virtual Memory:"
        'PRINT "  "; FreeExtendedMeml; " bytes"
        ' MEMUSAGE by Steve ]
    $END IF

    IF COMMAND$ = "" THEN PRINT: PRINT "May press Alt+X or Alt+Q to eXit/Quit..."
    ReturnCOMBO
    _DISPLAY

    $IF WINDOWS THEN
        IF _TOTALDROPPEDFILES THEN
            'FOR i = 1 TO _TOTALDROPPEDFILES
            'a$ = _DROPPEDFILE(i)
            a$ = _DROPPEDFILE(1)
            'NEXT'
            _FINISHDROP 'If _FINISHDROP isn't called here then _TOTALDROPPEDFILES never gets reset.
            'ELSE
            'a$ = "Scroller.$$$"
            'SHELL _HIDE "DIR /B *.* > Scroller.$$$"
        END IF
    $END IF
    IF COMMAND$ <> "" THEN a$ = COMMAND$

    'WrapFlag = 0
    'Wwidth% = XdimCOL
    'ul& = 0
    'LongestLine = 0
    'DO WHILE NOT EOF(1)
    '    LINE INPUT #1, l$: ul& = ul& + 1
    '    ExpandTabs l$
    '    IF LEN(l$) > LongestLine THEN LongestLine = LEN(l$)
    '    IF WrapFlag THEN
    '        lX$ = l$
    '        DO WHILE LEN(lX$) > Wwidth%
    '            Glupak% = Wwidth%
    '            DO UNTIL MID$(lX$, Glupak% + 1, 1) = " " AND MID$(lX$, Glupak%, 1) <> " "
    '                Glupak% = Glupak% - 1
    '                IF Glupak% = 0 THEN
    '                    PRINT "Rejecting line(#"; LTRIM$(STR$(ul&)); ", "; LTRIM$(STR$(LEN(l$))); "chars) that cannot be wrapped!"
    '                    _DISPLAY: SYSTEM
    '                    GOTO B4Txpanar
    '                END IF
    '            LOOP
    '            PRINT #3, LEFT$(lX$, Glupak%)
    '            lX$ = STRING$(1, " ") + LTRIM$(MID$(lX$, Glupak% + 1, LEN(lX$) - (Glupak%)))
    '        LOOP
    '        PRINT #3, lX$
    '        B4Txpanar:
    '    END IF
    'LOOP

    LongestLine = 0
    IF _FILEEXISTS(a$) THEN
        PRINT: PRINT "Loading..."
        _DISPLAY
        filecount = 0
'        OPEN a$ FOR INPUT AS #1
        OPEN a$ FOR BINARY AS #1 ' As suggested by SMcNeill and Pete in https://www.qb64.org/forum/index.php?topic=3518.msg128631#msg128631
        DO UNTIL EOF(1)
            LINE INPUT #1, l$
            filecount = filecount + 1
        LOOP
        CLOSE #1
        REDIM FileArray$(1 TO filecount)
        filecount = 0
'        OPEN a$ FOR INPUT AS #1
        OPEN a$ FOR BINARY AS #1 ' As suggested by SMcNeill and Pete in https://www.qb64.org/forum/index.php?topic=3518.msg128631#msg128631
        FileSize = LOF(1)
        DO UNTIL EOF(1)
            LINE INPUT #1, l$
            ExpandTabs l$
            FOR j = 1 TO LEN(l$)
                IF MID$(l$, j, 1) < CHR$(32) THEN MID$(l$, j, 1) = CHR$(32)
            NEXT j
            IF LEN(l$) > LongestLine THEN LongestLine = LEN(l$)
            filecount = filecount + 1
            FileArray$(filecount) = l$
        LOOP
        CLOSE #1
    END IF
    _LIMIT 5
    'IF INKEY$ = CHR$(27) THEN SYSTEM
    'IF keycode& = 27 THEN SYSTEM
    IF (_KEYDOWN(LALTkey&) OR _KEYDOWN(RALTkey&)) AND (_KEYDOWN(81) OR _KEYDOWN(113)) THEN SYSTEM
    IF (_KEYDOWN(LALTkey&) OR _KEYDOWN(RALTkey&)) AND (_KEYDOWN(88) OR _KEYDOWN(120)) THEN SYSTEM

    '                            QB64 _KEYHIT and _KEYDOWN Values
    '
    'Esc  F1    F2    F3    F4    F5    F6    F7    F8    F9    F10   F11   F12   Sys  ScL Pause
    ' 27 15104 15360 15616 15872 16128 16384 16640 16896 17152 17408 34048 34304 +316 +302 +019
    '`~  1!  2@  3#  4$  5%  6^  7&  8*  9(  0) -_ =+ BkSp   Ins   Hme   PUp   NumL   /     *    -
    '126 33  64  35  36  37  94  38  42  40  41 95 43   8   20992 18176 18688 +300   47    42   45
    ' 96 49  50  51  52  53  54  55  56  57  48 45 61
    'Tab Q   W   E   R   T   Y   U   I   O   P  [{  ]}  \|   Del   End   PDn   7Hme  8/?   9PU   +
    ' 9  81  87  69  82  84  89  85  73  79  80 123 125 124 21248 20224 20736 18176 18432 18688 43
    '   113 119 101 114 116 121 117 105 111 112  91  93  92                    55    56    57
    'CapL   A   S   D   F   G   H   J   K   L   ;:  '" Enter                   4/?-   5    6/-?
    '+301   65  83  68  70  71  72  74  75  76  58  34  13                    19200 19456 19712  E
    '       97 115 100 102 103 104 106 107 108  59  39                         52    53    54    n
    'Shift   Z   X   C   V   B   N   M   ,<  .>  /?    Shift       ?           1End  2/?   3PD   t
    '+304   90  88  67  86  66  78  77  60  62  63    +303       18432        20224 20480 20736  e
    '      122 120  99 118  98 110 109  44  46  47                             49    50    51    r
    'Ctrl   Win  Alt     Spacebar      Alt  Win  Menu  Ctrl   ?-   ?   -?      0Ins        .Del
    '+306  +311 +308       32         +307 +312 +319  +305 19200 20480 19712  20992       21248 13
    '                                                                          48          46
    '         Lower value = LCase/NumLock On __________________ + = add 100000

LOOP WHILE a$ = ""

TimeB = TIMER
PLAY "L8V2a-c-"
CurrentLine = 1
FOR i = 1 TO YdimROW
    LOCATE i, 1: PRINT SPACE$(XdimCOL);
NEXT
FOR i = 1 TO MIN&(YdimROW, filecount)
    IF LEN(FileArray$(i)) >= XdimCOL THEN
        FileArrayWINDOW$(i) = MID$(FileArray$(i), 1, XdimCOL)
    ELSE
        FileArrayWINDOW$(i) = FileArray$(i) + SPACE$(XdimCOL - LEN(FileArray$(i)))
    END IF
    LOCATE i, 1: PRINT FileArrayWINDOW$(i);
NEXT

' Here is the layout:
' The window-frame is 1..crx or 1..128 |  The file-frame is 1..LongestLine
'                     .         .      |                    .
'                     .         .      |                    .
'                     cry       60     |                    filecount
'              FileArrayWINDOW$(60)    |          FileArray(filecount)
' if File_Frame_x < 128 then PADDING to 128 else File_Frame_x = 1..LongestLine-(128-1)
' if File_Frame_y < 60 then PADDING to 60 else File_Frame_y = 1..filecount-(60-1)

UpdateCLine 1, 1, InverseFRGr, InverseBCKGr, 1
StatuLine$ = SPACE$(XdimCOL)
MID$(StatuLine$, 1, 1) = "["
MID$(StatuLine$, XdimCOL, 1) = "]"

Dumbo$ = "File Size: " + AddCommas$(FileSize) + "; Longest Line: " + AddCommas$(LongestLine) + "; Total Lines: " + AddCommas$(filecount)
MID$(StatuLine$, 2, LEN(Dumbo$)) = Dumbo$
LOCATE YdimROW + 1, 1: COLOR 9, 0: PRINT StatuLine$;
UpdateCLL CurrentLine, LEN(Dumbo$) + 1 + 1
CLL_Field = LEN(AddCommas$(LongestLine))
MostRightField = LEN(Dumbo$) + 1 + 1 + (LEN("; Current Line Length: ") + CLL_Field)
UpdateNextToCCL_DONE MostRightField

_DISPLAY
LOCATE 1, 1, 1, 30, 31
crx = POS(0)
cry = CSRLIN
crxOLD = crx
cryOLD = cry
File_Frame_x = 1
File_Frame_y = 1

DO
    ReturnCOMBO
    IF LSHIFT_RSHIFT THEN
        PLAY "L4V2f": _KEYCLEAR
        ReportTimeToLoad MostRightField
        _DISPLAY
    END IF
    IF (_KEYDOWN(LALTkey&) OR _KEYDOWN(RALTkey&)) AND (_KEYDOWN(81) OR _KEYDOWN(113)) THEN SYSTEM
    IF (_KEYDOWN(LALTkey&) OR _KEYDOWN(RALTkey&)) AND (_KEYDOWN(88) OR _KEYDOWN(120)) THEN SYSTEM
    key$ = INKEY$
    'DO: a$ = INKEY$: LOOP UNTIL a$ <> "" ' prevent ASC empty string read error
    IF key$ <> "" THEN
        code% = ASC(key$):
        IF code% THEN ' ASC returns any value greater than 0
            SELECT CASE ASC(key$)
                CASE 65 TO 97: 'PRINT key$;
                CASE ASC("a") TO ASC("z"): 'PRINT key$;
                    'CASE 27: COLOR 7, 0: SYSTEM 'END
            END SELECT
        ELSE
            SELECT CASE ASC(key$, 2)
                CASE 72:
                    IF CurrentLine > 1 THEN CurrentLine = CurrentLine - 1
                    IF cry > 1 THEN
                        cry = cry - 1 'up
                    ELSE 'scrolling is needed
                        IF File_Frame_y > 1 THEN File_Frame_y = File_Frame_y - 1
                        UpdateWindowFrame NormalFRGr, NormalBCKGr
                    END IF
                CASE 80:
                    IF CurrentLine < filecount THEN CurrentLine = CurrentLine + 1
                    IF cry < YdimROW THEN
                        IF cry < filecount THEN cry = cry + 1 'down
                    ELSE 'scrolling is needed
                        IF File_Frame_y < filecount - (YdimROW - 1) THEN File_Frame_y = File_Frame_y + 1
                        UpdateWindowFrame NormalFRGr, NormalBCKGr
                    END IF
                CASE 75: IF crx > 1 THEN crx = crx - 1 'left
                CASE 77: IF crx < XdimCOL THEN crx = crx + 1 'right
            END SELECT
        END IF
    END IF
    IF cryOLD <> cry THEN
        UpdateCLine cryOLD, 1, NormalFRGr, NormalBCKGr, cryOLD
        cryOLD = cry
    ELSE 'it 'cry' could be changed by Mouse Wheel too, check it
        AsIfItIsINKEY% = _MOUSEINPUT '      Check the mouse status
        IF _MOUSEWHEEL = 1 THEN ' as if Down
            IF CurrentLine < filecount THEN CurrentLine = CurrentLine + 1
            IF cry < YdimROW THEN
                IF cry < filecount THEN cry = cry + 1 'down
            ELSE 'scrolling is needed
                IF File_Frame_y < filecount - (YdimROW - 1) THEN File_Frame_y = File_Frame_y + 1
                UpdateWindowFrame NormalFRGr, NormalBCKGr
            END IF
        END IF
        IF _MOUSEWHEEL = -1 THEN ' as if Up
            IF CurrentLine > 1 THEN CurrentLine = CurrentLine - 1
            IF cry > 1 THEN
                cry = cry - 1 'up
            ELSE 'scrolling is needed
                IF File_Frame_y > 1 THEN File_Frame_y = File_Frame_y - 1
                UpdateWindowFrame NormalFRGr, NormalBCKGr
            END IF
        END IF
        IF _MOUSEBUTTON(1) THEN
            crxOLD = crx
            cryOLD = cry
            cry = _MOUSEY
            crx = _MOUSEX
            UpdateCLine cryOLD, 1, NormalFRGr, NormalBCKGr, cryOLD
            DO WHILE cryOLD > cry
                cryOLD = cryOLD - 1
                IF CurrentLine > 1 THEN CurrentLine = CurrentLine - 1
            LOOP
            DO WHILE cryOLD < cry
                cryOLD = cryOLD + 1
                IF CurrentLine < filecount THEN CurrentLine = CurrentLine + 1
            LOOP
        END IF
        IF _MOUSEBUTTON(3) THEN 'PgDn - just add the page height i.e. 'YdimROW' to 'File_Frame_y'
            ' Don't execute PgDn (advancing the 'CurrentLine') if 'File_Frame_y' is not "eligible":
            'IF File_Frame_y < filecount - (YdimROW - 1) THEN File_Frame_y = File_Frame_y + 1
            'IF File_Frame_y + 1 <= filecount - (YdimROW - 1) THEN File_Frame_y = File_Frame_y + 1
            'CAUTION [
            ' Next three line beep NOT
            'DEFLNG A-Z
            'aaa = 61
            'bbb = -48
            'IF aaa <= bbb THEN BEEP: END
            'Next three line beep
            'aaa~& = 61
            'bbb~& = -48
            'IF aaa~& <= bbb~& THEN BEEP: END
            'Next three line beep NOT
            'aaa& = 61
            'bbb& = -48
            'IF aaa& <= bbb& THEN BEEP: END
            'Next line works even when unsigned!
            'IF File_Frame_y + YdimROW - (filecount - (YdimROW - 1)) <= 0 THEN
            'CAUTION ]
            'Next line doesn't work when unsigned!
            IF File_Frame_y + YdimROW <= filecount - (YdimROW - 1) THEN
                File_Frame_y = File_Frame_y + YdimROW
                'IF CurrentLine < filecount THEN CurrentLine = CurrentLine + 1
                'IF CurrentLine + 1 <= filecount THEN CurrentLine = CurrentLine + 1
                IF CurrentLine + YdimROW <= filecount THEN CurrentLine = CurrentLine + YdimROW
                UpdateWindowFrame NormalFRGr, NormalBCKGr
            END IF
        END IF
    END IF
    IF cryOLD <> cry THEN
        UpdateCLine cryOLD, 1, NormalFRGr, NormalBCKGr, cryOLD
        cryOLD = cry
    END IF
    IF LCTRL_HOME THEN
        LOCATE 1, 1, 1, 30, 31
        crx = POS(0)
        cry = CSRLIN
        crxOLD = crx
        cryOLD = cry
        File_Frame_x = 1
        File_Frame_y = 1
        CurrentLine = 1
        UpdateWindowFrame NormalFRGr, NormalBCKGr
    END IF
    IF LCTRL_END THEN
        IF filecount >= YdimROW THEN
            IF filecount - (YdimROW - 1) THEN
                LOCATE YdimROW, 1, 1, 30, 31
                crx = POS(0)
                cry = CSRLIN
                crxOLD = crx
                cryOLD = cry
                File_Frame_x = 1
                File_Frame_y = filecount - (YdimROW - 1)
                CurrentLine = filecount
                UpdateWindowFrame NormalFRGr, NormalBCKGr
            END IF
        ELSE
            LOCATE filecount, 1, 1, 30, 31
            crx = POS(0)
            cry = CSRLIN
            crxOLD = crx
            cryOLD = cry
            File_Frame_x = 1
            File_Frame_y = 1
            CurrentLine = filecount
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        END IF
    END IF

    LOCATE cry, crx, 1, 30, 31
    UpdateCLine cry, 1, InverseFRGr, InverseBCKGr, cry
    UpdateCLL CurrentLine, LEN(Dumbo$) + 1 + 1
    _DISPLAY
    'DO WHILE INKEY$ <> "": LOOP ' have to clear the keyboard buffer
    _LIMIT 500 '_LIMIT 30 'commented because the wheel up/down was not working?!
LOOP

END


'_TITLE "Mouse Feedback"
'DO
'    DO WHILE _MOUSEINPUT '      Check the mouse status
'        PRINT _MOUSEX, _MOUSEY, _MOUSEBUTTON(1); _MOUSEBUTTON(2); _MOUSEBUTTON(3), _MOUSEWHEEL
'    LOOP
'LOOP UNTIL INKEY$ <> ""

'Syntax:
'infoExists%% = _MOUSEINPUT

'Description:
'- Returns -1 if new mouse information is available, otherwise it returns 0.
'- Must be called before reading any of the other mouse functions. The function will not miss any
'  mouse input even during an INPUT entry.
'- Use in a loop to monitor the mouse buttons, scroll wheel and coordinate positions.
'-  To clear all previous mouse data, use _MOUSEINPUT in a loop until it returns 0.



' _FONT (function) creates a new alphablended font handle from a designated image handle
' _FONT (statement) sets the current _LOADFONT function font handle to be used by PRINT or
'  _PRINTSTRING.
' _FONTHEIGHT (function) returns the font height of a font handle created by _LOADFONT.
' _FONTWIDTH (function) returns the font width of a MONOSPACE font handle created by _LOADFONT.
' _FREEFONT (statement) frees a font handle value from memory
' _LOADFONT (function) loads a TrueType font (.TTF) file of a specific size and style and returns
'  a font handle value.

' _DISPLAY (statement) turns off automatic display while only displaying the screen changes when
'  called.

' SHELL (QB64 function) executes a DOS command or calls another program. Returns codes sent by END
'  or SYSTEM.
' _SHELLHIDE (function) hides a DOS command or call to another program. Returns codes sent by END
'  or SYSTEM.


' _CWD$ (function) returns the current working directory path as a STRING.
' _DONTWAIT (SHELL action) allows the program to continue without waiting for the other program to
'  close.
' _FILEEXISTS (function) returns -1 if the file name string parameter exists. Zero if it does not.
' _HIDE (SHELL action) hides the DOS screen output during a shell.

' _SHELLHIDE (function) executes a DOS command or calls another program. Returns codes sent by END
'  or SYSTEM.
' _STARTDIR$ (function) returns the user's program calling path as a STRING.



'The _MEMNEW function allocates new memory and returns a _MEM memory block referring to it.

'Syntax:
'     memoryBlock = _MEMNEW(byteSize)

'- The byteSize parameter is the desired byte size of the memory block based on the variable type
'  it will hold.

'Description:
'- The memoryBlock value created holds the elements .OFFSET, .SIZE, .TYPE and .ELEMENTSIZE.
'- _MEMNEW does not clear the data previously in the memory block it allocates, for speed purposes.
'- To clear previous data from a new memory block, use _MEMFILL with a byte value of 0.
'- When a new memory block is created the memory .TYPE value will be 0.
'- If the read only memory block .SIZE is 0, the memory block was not created.
'- All values created by memory functions must be freed using _MEMFREE with a valid _MEM variable.

'Code Examples:
'Example: Shows how SINGLE numerical values can be passed, but non-fixed STRING lengths cannot get
'the value.

'DIM m AS _MEM
'DIM f AS STRING * 5
'm = _MEMNEW(5) 'create new memory block of 5 bytes
'a = 12345.6
'_MEMPUT m, m.OFFSET, a 'put single value
'_MEMGET m, m.OFFSET, b 'get single value
'PRINT "b = "; b
'c$ = "Doggy"
'_MEMPUT m, m.OFFSET, c$ 'put 5 byte string value
'_MEMGET m, m.OFFSET, d$ 'get unfixed length string value
'_MEMGET m, m.OFFSET, f  'get 5 byte string value
'e$ = _MEMGET(m, m.OFFSET, STRING * 5) 'get 5 byte string value
'PRINT "d$ = "; d$; LEN(d$) 'prints empty string
'PRINT "e$ = "; e$; LEN(e$)
'PRINT "f = "; f; LEN(f)



''OPENICON.BAS
''============
''Maximizes a minimized program using WinAPI.
''By Dav, DEC/2020

'DECLARE DYNAMIC LIBRARY "user32"
'    FUNCTION OpenIcon& (BYVAL hwnd AS LONG)
'END DECLARE

'PRINT
'PRINT "Minimize this program at it will pop back up in 2 secs."

'DO
'    IF _SCREENICON THEN
'        SLEEP 2: x& = OpenIcon&(_WINDOWHANDLE)
'    END IF
'LOOP

' http://www.qb64.org/wiki/CONSOLETITLE
'Example: Hiding the main program window while displaying the console window with a title.

SUB ReturnCOMBO
    SHARED LSHIFT_RSHIFT
    SHARED LCTRL_RCTRL
    SHARED LALT_RALT

    SHARED LALT_HOME
    SHARED LALT_END

    SHARED LALT_INS
    SHARED LALT_DEL

    SHARED LALT_PGUP
    SHARED LALT_PGDN

    SHARED LALT_Left
    SHARED LALT_Right
    SHARED LALT_Up
    SHARED LALT_Down

    SHARED RALT_HOME
    SHARED RALT_END

    SHARED RALT_INS
    SHARED RALT_DEL

    SHARED RALT_PGUP
    SHARED RALT_PGDN

    SHARED RALT_Left
    SHARED RALT_Right
    SHARED RALT_Up
    SHARED RALT_Down

    SHARED LSHIFT_HOME
    SHARED LSHIFT_END

    SHARED LSHIFT_INS
    SHARED LSHIFT_DEL

    SHARED LSHIFT_PGUP
    SHARED LSHIFT_PGDN

    SHARED LSHIFT_Left
    SHARED LSHIFT_Right
    SHARED LSHIFT_Up
    SHARED LSHIFT_Down

    SHARED RSHIFT_HOME
    SHARED RSHIFT_END

    SHARED RSHIFT_INS
    SHARED RSHIFT_DEL

    SHARED RSHIFT_PGUP
    SHARED RSHIFT_PGDN

    SHARED RSHIFT_Left
    SHARED RSHIFT_Right
    SHARED RSHIFT_Up
    SHARED RSHIFT_Down

    SHARED LCTRL_HOME
    SHARED LCTRL_END

    SHARED LCTRL_INS
    SHARED LCTRL_DEL

    SHARED LCTRL_PGUP
    SHARED LCTRL_PGDN

    SHARED LCTRL_Left
    SHARED LCTRL_Right
    SHARED LCTRL_Up
    SHARED LCTRL_Down

    SHARED RCTRL_HOME
    SHARED RCTRL_END

    SHARED RCTRL_INS
    SHARED RCTRL_DEL

    SHARED RCTRL_PGUP
    SHARED RCTRL_PGDN

    SHARED RCTRL_Left
    SHARED RCTRL_Right
    SHARED RCTRL_Up
    SHARED RCTRL_Down

    SHARED LSHIFT_LCTRL_HOME
    SHARED LSHIFT_LCTRL_END

    SHARED LSHIFT_LCTRL_INS
    SHARED LSHIFT_LCTRL_DEL

    SHARED LSHIFT_LCTRL_PGUP
    SHARED LSHIFT_LCTRL_PGDN

    SHARED LSHIFT_LCTRL_Left
    SHARED LSHIFT_LCTRL_Right
    SHARED LSHIFT_LCTRL_Up
    SHARED LSHIFT_LCTRL_Down

    SHARED LSHIFT_BackSpace
    SHARED LSHIFT_TAB
    SHARED LSHIFT_SPACE
    SHARED LSHIFT_ESC
    SHARED LSHIFT_ENTER

    SHARED RSHIFT_BackSpace
    SHARED RSHIFT_TAB
    SHARED RSHIFT_SPACE
    SHARED RSHIFT_ESC
    SHARED RSHIFT_ENTER

    SHARED LCTRL_SPACE
    SHARED LCTRL_ENTER

    SHARED RCTRL_SPACE
    SHARED RCTRL_ENTER

    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(RSHIFTkey&) THEN LSHIFT_RSHIFT = 1 ELSE LSHIFT_RSHIFT = 0
    IF _KEYDOWN(LCTRLkey&) AND _KEYDOWN(RCTRLkey&) THEN LCTRL_RCTRL = 1 ELSE LCTRL_RCTRL = 0
    IF _KEYDOWN(LALTkey&) AND _KEYDOWN(RALTkey&) THEN LALT_RALT = 1 ELSE LALT_RALT = 0

    'LALT:
    IF _KEYDOWN(LALTkey&) AND _KEYDOWN(HOMEkey&) THEN LALT_HOME = 1 ELSE LALT_HOME = 0
    IF _KEYDOWN(LALTkey&) AND _KEYDOWN(ENDkey&) THEN LALT_END = 1 ELSE LALT_END = 0

    IF _KEYDOWN(LALTkey&) AND _KEYDOWN(INSkey&) THEN LALT_INS = 1 ELSE LALT_INS = 0
    IF _KEYDOWN(LALTkey&) AND _KEYDOWN(DELkey&) THEN LALT_DEL = 1 ELSE LALT_DEL = 0

    IF _KEYDOWN(LALTkey&) AND _KEYDOWN(PGUPkey&) THEN LALT_PGUP = 1 ELSE LALT_PGUP = 0
    IF _KEYDOWN(LALTkey&) AND _KEYDOWN(PGDNkey&) THEN LALT_PGDN = 1 ELSE LALT_PGDN = 0

    IF _KEYDOWN(LALTkey&) AND _KEYDOWN(LEFTkey&) THEN LALT_Left = 1 ELSE LALT_Left = 0
    IF _KEYDOWN(LALTkey&) AND _KEYDOWN(RIGHTkey&) THEN LALT_Right = 1 ELSE LALT_Right = 0
    IF _KEYDOWN(LALTkey&) AND _KEYDOWN(UPkey&) THEN LALT_Up = 1 ELSE LALT_Up = 0
    IF _KEYDOWN(LALTkey&) AND _KEYDOWN(DOWNkey&) THEN LALT_Down = 1 ELSE LALT_Down = 0

    'RALT:
    IF _KEYDOWN(RALTkey&) AND _KEYDOWN(HOMEkey&) THEN RALT_HOME = 1 ELSE RALT_HOME = 0
    IF _KEYDOWN(RALTkey&) AND _KEYDOWN(ENDkey&) THEN RALT_END = 1 ELSE RALT_END = 0

    IF _KEYDOWN(RALTkey&) AND _KEYDOWN(INSkey&) THEN RALT_INS = 1 ELSE RALT_INS = 0
    IF _KEYDOWN(RALTkey&) AND _KEYDOWN(DELkey&) THEN RALT_DEL = 1 ELSE RALT_DEL = 0

    IF _KEYDOWN(RALTkey&) AND _KEYDOWN(PGUPkey&) THEN RALT_PGUP = 1 ELSE RALT_PGUP = 0
    IF _KEYDOWN(RALTkey&) AND _KEYDOWN(PGDNkey&) THEN RALT_PGDN = 1 ELSE RALT_PGDN = 0

    IF _KEYDOWN(RALTkey&) AND _KEYDOWN(LEFTkey&) THEN PRINT RALT_Left = 1 ELSE RALT_Left = 0
    IF _KEYDOWN(RALTkey&) AND _KEYDOWN(RIGHTkey&) THEN RALT_Right = 1 ELSE RALT_Right = 0
    IF _KEYDOWN(RALTkey&) AND _KEYDOWN(UPkey&) THEN RALT_Up = 1 ELSE RALT_Up = 0
    IF _KEYDOWN(RALTkey&) AND _KEYDOWN(DOWNkey&) THEN RALT_Down = 1 ELSE RALT_Down = 0

    'LSHIFT:
    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(HOMEkey&) THEN LSHIFT_HOME = 1 ELSE LSHIFT_HOME = 0
    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(ENDkey&) THEN LSHIFT_END = 1 ELSE LSHIFT_END = 0

    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(INSkey&) THEN LSHIFT_INS = 1 ELSE LSHIFT_INS = 0
    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(DELkey&) THEN LSHIFT_DEL = 1 ELSE LSHIFT_DEL = 0

    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(PGUPkey&) THEN LSHIFT_PGUP = 1 ELSE LSHIFT_PGUP = 0
    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(PGDNkey&) THEN LSHIFT_PGDN = 1 ELSE LSHIFT_PGDN = 0

    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(LEFTkey&) THEN LSHIFT_Left = 1 ELSE LSHIFT_Left = 0
    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(RIGHTkey&) THEN LSHIFT_Right = 1 ELSE LSHIFT_Right = 0
    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(UPkey&) THEN LSHIFT_Up = 1 ELSE LSHIFT_Up = 0
    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(DOWNkey&) THEN LSHIFT_Down = 1 ELSE LSHIFT_Down = 0

    'RSHIFT:
    IF _KEYDOWN(RSHIFTkey&) AND _KEYDOWN(HOMEkey&) THEN RSHIFT_HOME = 1 ELSE RSHIFT_HOME = 0
    IF _KEYDOWN(RSHIFTkey&) AND _KEYDOWN(ENDkey&) THEN RSHIFT_END = 1 ELSE RSHIFT_END = 0

    IF _KEYDOWN(RSHIFTkey&) AND _KEYDOWN(INSkey&) THEN RSHIFT_INS = 1 ELSE RSHIFT_INS = 0
    IF _KEYDOWN(RSHIFTkey&) AND _KEYDOWN(DELkey&) THEN RSHIFT_DEL = 1 ELSE RSHIFT_DEL = 0

    IF _KEYDOWN(RSHIFTkey&) AND _KEYDOWN(PGUPkey&) THEN RSHIFT_PGUP = 1 ELSE RSHIFT_PGUP = 0
    IF _KEYDOWN(RSHIFTkey&) AND _KEYDOWN(PGDNkey&) THEN RSHIFT_PGDN = 1 ELSE RSHIFT_PGDN = 0

    IF _KEYDOWN(RSHIFTkey&) AND _KEYDOWN(LEFTkey&) THEN RSHIFT_Left = 1 ELSE RSHIFT_Left = 0
    IF _KEYDOWN(RSHIFTkey&) AND _KEYDOWN(RIGHTkey&) THEN RSHIFT_Right = 1 ELSE RSHIFT_Right = 0
    IF _KEYDOWN(RSHIFTkey&) AND _KEYDOWN(UPkey&) THEN RSHIFT_Up = 1 ELSE RSHIFT_Up = 0
    IF _KEYDOWN(RSHIFTkey&) AND _KEYDOWN(DOWNkey&) THEN RSHIFT_Down = 1 ELSE RSHIFT_Down = 0

    'LCTRL:
    IF _KEYDOWN(LCTRLkey&) AND _KEYDOWN(HOMEkey&) THEN LCTRL_HOME = 1 ELSE LCTRL_HOME = 0
    IF _KEYDOWN(LCTRLkey&) AND _KEYDOWN(ENDkey&) THEN LCTRL_END = 1 ELSE LCTRL_END = 0

    IF _KEYDOWN(LCTRLkey&) AND _KEYDOWN(INSkey&) THEN LCTRL_INS = 1 ELSE LCTRL_INS = 0
    IF _KEYDOWN(LCTRLkey&) AND _KEYDOWN(DELkey&) THEN LCTRL_DEL = 1 ELSE LCTRL_DEL = 0

    IF _KEYDOWN(LCTRLkey&) AND _KEYDOWN(PGUPkey&) THEN LCTRL_PGUP = 1 ELSE LCTRL_PGUP = 0
    IF _KEYDOWN(LCTRLkey&) AND _KEYDOWN(PGDNkey&) THEN LCTRL_PGDN = 1 ELSE LCTRL_PGDN = 0

    IF _KEYDOWN(LCTRLkey&) AND _KEYDOWN(LEFTkey&) THEN LCTRL_Left = 1 ELSE LCTRL_Left = 0
    IF _KEYDOWN(LCTRLkey&) AND _KEYDOWN(RIGHTkey&) THEN LCTRL_Right = 1 ELSE LCTRL_Right = 0
    IF _KEYDOWN(LCTRLkey&) AND _KEYDOWN(UPkey&) THEN LCTRL_Up = 1 ELSE LCTRL_Up = 0
    IF _KEYDOWN(LCTRLkey&) AND _KEYDOWN(DOWNkey&) THEN LCTRL_Down = 1 ELSE LCTRL_Down = 0

    'RCTRL:
    IF _KEYDOWN(RCTRLkey&) AND _KEYDOWN(HOMEkey&) THEN RCTRL_HOME = 1 ELSE RCTRL_HOME = 0
    IF _KEYDOWN(RCTRLkey&) AND _KEYDOWN(ENDkey&) THEN RCTRL_END = 1 ELSE RCTRL_END = 0

    IF _KEYDOWN(RCTRLkey&) AND _KEYDOWN(INSkey&) THEN RCTRL_INS = 1 ELSE RCTRL_INS = 0
    IF _KEYDOWN(RCTRLkey&) AND _KEYDOWN(DELkey&) THEN RCTRL_DEL = 1 ELSE RCTRL_DEL = 0

    IF _KEYDOWN(RCTRLkey&) AND _KEYDOWN(PGUPkey&) THEN RCTRL_PGUP = 1 ELSE RCTRL_PGUP = 0
    IF _KEYDOWN(RCTRLkey&) AND _KEYDOWN(PGDNkey&) THEN RCTRL_PGDN = 1 ELSE RCTRL_PGDN = 0

    IF _KEYDOWN(RCTRLkey&) AND _KEYDOWN(LEFTkey&) THEN RCTRL_Left = 1 ELSE RCTRL_Left = 0
    IF _KEYDOWN(RCTRLkey&) AND _KEYDOWN(RIGHTkey&) THEN RCTRL_Right = 1 ELSE RCTRL_Right = 0
    IF _KEYDOWN(RCTRLkey&) AND _KEYDOWN(UPkey&) THEN RCTRL_Up = 1 ELSE RCTRL_Up = 0
    IF _KEYDOWN(RCTRLkey&) AND _KEYDOWN(DOWNkey&) THEN RCTRL_Down = 1 ELSE RCTRL_Down = 0

    'LSHIFT+LCTRL: NOTICE: LSHIFT+LCTRL+Left triggers 3 variables on - 1] LSHIFT_LCTRL_Left 2] LSHIFT_Left 3] LCTRL_Left
    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(LCTRLkey&) AND _KEYDOWN(HOMEkey&) THEN LSHIFT_LCTRL_HOME = 1 ELSE LSHIFT_LCTRL_HOME = 0
    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(LCTRLkey&) AND _KEYDOWN(ENDkey&) THEN LSHIFT_LCTRL_END = 1 ELSE LSHIFT_LCTRL_END = 0

    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(LCTRLkey&) AND _KEYDOWN(INSkey&) THEN LSHIFT_LCTRL_INS = 1 ELSE LSHIFT_LCTRL_INS = 0
    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(LCTRLkey&) AND _KEYDOWN(DELkey&) THEN LSHIFT_LCTRL_DEL = 1 ELSE LSHIFT_LCTRL_DEL = 0

    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(LCTRLkey&) AND _KEYDOWN(PGUPkey&) THEN LSHIFT_LCTRL_PGUP = 1 ELSE LSHIFT_LCTRL_PGUP = 0
    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(LCTRLkey&) AND _KEYDOWN(PGDNkey&) THEN LSHIFT_LCTRL_PGDN = 1 ELSE LSHIFT_LCTRL_PGDN = 0

    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(LCTRLkey&) AND _KEYDOWN(LEFTkey&) THEN LSHIFT_LCTRL_Left = 1 ELSE LSHIFT_LCTRL_Left = 0
    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(LCTRLkey&) AND _KEYDOWN(RIGHTkey&) THEN LSHIFT_LCTRL_Right = 1 ELSE LSHIFT_LCTRL_Right = 0
    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(LCTRLkey&) AND _KEYDOWN(UPkey&) THEN LSHIFT_LCTRL_Up = 1 ELSE LSHIFT_LCTRL_Up = 0
    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(LCTRLkey&) AND _KEYDOWN(DOWNkey&) THEN LSHIFT_LCTRL_Down = 1 ELSE LSHIFT_LCTRL_Down = 0

    'LSHIFT:
    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(BACKSPCkey&) THEN LSHIFT_BackSpace = 1 ELSE LSHIFT_BackSpace = 0
    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(TABkey&) THEN LSHIFT_TAB = 1 ELSE LSHIFT_TAB = 0
    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(SPACEkey&) THEN LSHIFT_SPACE = 1 ELSE LSHIFT_SPACE = 0
    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(ESCkey&) THEN LSHIFT_ESC = 1 ELSE LSHIFT_ESC = 0
    IF _KEYDOWN(LSHIFTkey&) AND _KEYDOWN(ENTERkey&) THEN LSHIFT_ENTER = 1 ELSE LSHIFT_ENTER = 0
    'RSHIFT:
    IF _KEYDOWN(RSHIFTkey&) AND _KEYDOWN(BACKSPCkey&) THEN RSHIFT_BackSpace = 1 ELSE RSHIFT_BackSpace = 0
    IF _KEYDOWN(RSHIFTkey&) AND _KEYDOWN(TABkey&) THEN RSHIFT_TAB = 1 ELSE RSHIFT_TAB = 0
    IF _KEYDOWN(RSHIFTkey&) AND _KEYDOWN(SPACEkey&) THEN RSHIFT_SPACE = 1 ELSE RSHIFT_SPACE = 0
    IF _KEYDOWN(RSHIFTkey&) AND _KEYDOWN(ESCkey&) THEN RSHIFT_ESC = 1 ELSE RSHIFT_ESC = 0
    IF _KEYDOWN(RSHIFTkey&) AND _KEYDOWN(ENTERkey&) THEN RSHIFT_ENTER = 1 ELSE RSHIFT_ENTER = 0

    'LCTRL:
    IF _KEYDOWN(LCTRLkey&) AND _KEYDOWN(SPACEkey&) THEN LCTRL_SPACE = 1 ELSE LCTRL_SPACE = 0
    IF _KEYDOWN(LCTRLkey&) AND _KEYDOWN(ENTERkey&) THEN LCTRL_ENTER = 1 ELSE LCTRL_ENTER = 0
    'RCTRL:
    IF _KEYDOWN(RCTRLkey&) AND _KEYDOWN(SPACEkey&) THEN RCTRL_SPACE = 1 ELSE RCTRL_SPACE = 0
    IF _KEYDOWN(RCTRLkey&) AND _KEYDOWN(ENTERkey&) THEN RCTRL_ENTER = 1 ELSE RCTRL_ENTER = 0

    '_KEYCLEAR
END SUB

SUB ExpandTabs (l$)
    IF INSTR(l$, CHR$(9)) THEN
        TabV% = 8
        b$ = "": f& = 0
        FOR i& = 1 TO LEN(l$)
            IF MID$(l$, i&, 1) = CHR$(9) THEN
                b$ = b$ + STRING$((f& \ TabV%) * TabV% + TabV% - f&, " ")
                '  |
                '  |
                ' \|/
                'TabV% - (f% - (f% \ TabV%) * TabV%) =
                'TabV% - (f% MOD TabV%)
                f& = (f& \ TabV%) * TabV% + TabV%
            ELSE
                b$ = b$ + MID$(l$, i&, 1)
                f& = f& + 1
            END IF
        NEXT
        l$ = b$
    END IF
END SUB

FUNCTION MIN& (YdimROW, filecount)
    IF YdimROW < filecount THEN MIN& = YdimROW ELSE MIN& = filecount
END FUNCTION

FUNCTION AddCommas$ (numeral)
    s$ = LTRIM$(STR$(numeral))
    IF LEN(s$) > 3 THEN
        IF (LEN(s$) MOD 3) THEN x$ = STRING$(3 - (LEN(s$) MOD 3), " ") + s$ ELSE x$ = s$
        s$ = ""
        FOR i = 1 TO LEN(x$) STEP 3
            s$ = s$ + MID$(x$, i, 3) + ","
        NEXT
        s$ = LEFT$(s$, LEN(s$) - 1)
    END IF
    AddCommas$ = LTRIM$(s$)
END FUNCTION

SUB UpdateCLL (l, posit)
    SHARED CLL_Field
    SHARED YdimROW, FileArray$()
    crx = POS(0)
    cry = CSRLIN
    q$ = AddCommas$(LEN(FileArray$(l)))
    LOCATE YdimROW + 1, posit: COLOR 9, 0: PRINT "; Current Line Length: " + q$ + STRING$(CLL_Field - LEN(q$), " ");
    LOCATE cry, crx, 1, 30, 31
END SUB

SUB UpdateNextToCCL_BUSY (posit)
    SHARED YdimROW
    crx = POS(0)
    cry = CSRLIN
    LOCATE YdimROW + 1, posit: COLOR 9, 0: PRINT "; Status: BUSY";
    LOCATE cry, crx, 1, 30, 31
END SUB

SUB UpdateNextToCCL_DONE (posit)
    SHARED YdimROW
    crx = POS(0)
    cry = CSRLIN
    LOCATE YdimROW + 1, posit: COLOR 9, 0: PRINT "; Status: DONE";
    LOCATE cry, crx, 1, 30, 31
END SUB

SUB UpdateCLine (lineToWrite, columnToWrite, FRGR, BACKGR, ln)
    SHARED FileArrayWINDOW$()
    crx = POS(0)
    cry = CSRLIN
    COLOR FRGR, BACKGR
    LOCATE lineToWrite, columnToWrite, 1, 30, 31
    PRINT FileArrayWINDOW$(ln);
    LOCATE cry, crx, 1, 30, 31
END SUB

SUB UpdateWindowFrame (FRGR, BACKGR)
    SHARED YdimROW, filecount, FileArray$(), File_Frame_y, XdimCOL, FileArrayWINDOW$()
    COLOR FRGR, BACKGR
    FOR i = 1 TO MIN&(YdimROW, filecount)
        IF LEN(FileArray$(i + (File_Frame_y - 1))) >= XdimCOL THEN
            FileArrayWINDOW$(i) = MID$(FileArray$(i + (File_Frame_y - 1)), 1, XdimCOL)
        ELSE
            FileArrayWINDOW$(i) = FileArray$(i + (File_Frame_y - 1)) + SPACE$(XdimCOL - LEN(FileArray$(i + (File_Frame_y - 1))))
        END IF
        LOCATE i, 1: PRINT FileArrayWINDOW$(i);
    NEXT
END SUB

SUB ReportTimeToLoad (posit)
    SHARED YdimROW
    SHARED TimeA, TimeB
    crx = POS(0)
    cry = CSRLIN
    LOCATE YdimROW + 1, posit: COLOR 4, 0: PRINT "; Loaded in"; TimeB - TimeA; " seconds.";
    LOCATE cry, crx, 1, 30, 31
END SUB

